import { UseCollectionOptions, CollectionState, TrackBy } from '../interfaces';
import { ItemsTree } from './items-tree.js';
export declare function processItems<T>(items: ReadonlyArray<T>, { filteringText, sortingState, currentPageIndex, propertyFilteringQuery }: Partial<CollectionState<T>>, { filtering, sorting, pagination, propertyFiltering, expandableRows }: UseCollectionOptions<T>): {
    items: ReadonlyArray<T>;
    allPageItems: ReadonlyArray<T>;
    pagesCount: number | undefined;
    actualPageIndex: number | undefined;
    filteredItemsCount: number | undefined;
    itemsTree: ItemsTree<T>;
};
export declare const getTrackableValue: <T>(trackBy: TrackBy<T> | undefined, item: T) => string | T;
export declare const processSelectedItems: <T>(items: ReadonlyArray<T>, selectedItems: ReadonlyArray<T>, trackBy?: TrackBy<T>) => T[];
export declare const itemsAreEqual: <T>(items1: ReadonlyArray<T>, items2: ReadonlyArray<T>, trackBy?: TrackBy<T>) => boolean;
