import { ExpandableRowsProps } from '../interfaces';
export declare class ItemsTree<T> {
    private size;
    private items;
    private treeProps?;
    private hasNesting;
    private roots;
    private idToChildren;
    constructor(items: ReadonlyArray<T>, treeProps?: ExpandableRowsProps<T>);
    filter: (predicate: (item: T) => boolean) => ItemsTree<T>;
    sort: (comparator: (a: T, b: T) => number) => ItemsTree<T>;
    getChildren: (item: T) => T[];
    getItems: () => ReadonlyArray<T>;
    getSize: () => number;
    private setChildren;
    private filterTree;
    private sortTree;
}
